package de.privacynerd.chatbeautifier;

import de.privacynerd.chatbeautifier.displaynamecolor.ChatColorCommand;
import de.privacynerd.chatbeautifier.displaynamecolor.ChooseChatColorListener;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.bukkit.plugin.PluginManager;
import org.bukkit.plugin.java.JavaPlugin;
import org.jetbrains.annotations.NotNull;


public final class ChatBeautifier extends JavaPlugin {
    public static Component PREFIX = Component.text("[ChatBeautifier] ", NamedTextColor.DARK_AQUA);
    public static ChatBeautifier INSTANCE;

    public ChatBeautifier() {
        INSTANCE = this;
    }

    // some log functions
    public void log(String message) { Bukkit.getConsoleSender().sendMessage(PREFIX.append(Component.text(message, NamedTextColor.GRAY))); }
    public void log(@NotNull Component message) { Bukkit.getConsoleSender().sendMessage(PREFIX.append(message.color(NamedTextColor.GRAY))); }
    public void tellPlayer(String message, @NotNull Player player) { player.sendMessage(PREFIX.append(Component.text(message, NamedTextColor.GRAY))); }
    public void tellPlayer(@NotNull Component message, @NotNull Player player) { player.sendMessage(PREFIX.append(message.color(NamedTextColor.GRAY))); }


    @Override
    public void onEnable() {  // the plugin startup logic
        // register listeners
        PluginManager pluginManager = Bukkit.getPluginManager();
        pluginManager.registerEvents(new JoinQuitListener(), this);
        log("JoinQuitListener has been registered.");
        pluginManager.registerEvents(new ChatListener(), this);
        log("ChatListener has been registered.");
        pluginManager.registerEvents(new ChooseChatColorListener(), this);
        log("ChooseChatColorListener has been registered.");

        Bukkit.getPluginCommand("set-chat-color").setExecutor(new ChatColorCommand());
        log("ChatColorCommand has been set as executor for the command 'set-chat-color'.");

        log("Plugin enabled.");
    }

    @Override
    public void onDisable() {
        log("Plugin disabled.");
    }
}