package de.privacynerd.chatbeautifier.displaynamecolor;

import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import net.kyori.adventure.text.format.TextColor;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import de.privacynerd.chatbeautifier.displaynamecolor.ChatColorUtils;

import java.util.ArrayList;

public class ChooseChatColorGUI {

    public Inventory getGUI(Player player) {
        Inventory gui = Bukkit.createInventory(player, 45, Component.text("Set chat color (0x01)", NamedTextColor.DARK_GRAY));

        // create item stacks to be filled into the gui later
        ItemStack nothing = new ItemStack(Material.LIGHT_BLUE_STAINED_GLASS_PANE);  // for filling the gaps

        ArrayList<ItemStack> chooseColorItems = ChatColorUtils.getChooseColorItems();
        ArrayList<String> chooseColorNames = ChatColorUtils.getChooseColorStrings();
        ArrayList<TextColor> chooseColorCodes = ChatColorUtils.getChooseColorCodes();

        for (int i=0; i<15; i++) {
            ItemMeta color_meta = nothing.getItemMeta();
            if(i==0) {  // make it the black text readable
                color_meta.displayName(Component.text(chooseColorNames.get(i), NamedTextColor.WHITE));
            } else {
                color_meta.displayName(Component.text(chooseColorNames.get(i), chooseColorCodes.get(i)));
            }
            chooseColorItems.get(i).setItemMeta(color_meta);
        }

        // set item metas (so that a listener can correctly identify the items)
        ItemMeta nothing_meta = nothing.getItemMeta();
        nothing_meta.displayName(Component.text(" "));
        nothing.setItemMeta(nothing_meta);

        // fill the glass panes
        for (int i=0; i<11; i++) { gui.setItem(i, nothing); }
        for (int i=0; i<3; i++) {
            gui.setItem(16 + (8 * i) + i, nothing);
            gui.setItem(16 + (8 * i) + i + 1, nothing);
            gui.setItem(16 + (8 * i) + i + 2, nothing);
            gui.setItem(16 + (8 * i) + i + 3, nothing);
        }
        for (int i=38; i<45; i++) { gui.setItem(i, nothing); }

        for(int i=0; i<3; i++) {
            gui.setItem(11 + (8 * i) + i, chooseColorItems.get((4 * i) + i));
            gui.setItem(11 + (8 * i) + i +1, chooseColorItems.get((4 * i) + i +1));
            gui.setItem(11 + (8 * i) + i +2, chooseColorItems.get((4 * i) + i +2));
            gui.setItem(11 + (8 * i) + i +3, chooseColorItems.get((4 * i) + i +3));
            gui.setItem(11 + (8 * i) + i +4, chooseColorItems.get((4 * i) + i +4));
        }

        return gui;
    }
}