package de.privacynerd.chatbeautifier.utils;

import de.privacynerd.chatbeautifier.displaynamecolor.ChatColorUtils;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import net.kyori.adventure.text.format.TextColor;
import net.kyori.adventure.text.format.TextDecoration;
import org.bukkit.entity.Player;

public class DisplayNameSetter {
    public static void setName(Player player, Component newName) {
        player.displayName(newName);
        player.playerListName(newName);
    }

    public static void setName(Player player) {
        Component newName;
        TextColor textColor = NamedTextColor.GRAY;  // default to gray

        // get a potentially saved color (set from /set-chat-color command)
        FileConfig chatColorConfig = new FileConfig(ConfigFilenames.chatNameColors);
        String UUID_String = player.getUniqueId().toString();
        if ( chatColorConfig.contains(UUID_String) ) {
            int colorIndex = chatColorConfig.getInt(UUID_String);
            textColor = ChatColorUtils.getChooseColorCodes().get(colorIndex);
        }

        // now compose the name (distinguish between operators and normal players by a red, bold [OP] in the beginning
        if(player.isOp()) {
            newName = Component.text("[OP] ")
                    .color(NamedTextColor.RED)
                    .decoration(TextDecoration.BOLD, true)
                    .append(Component.text(player.getName())
                            .color(textColor)
                            .decoration(TextDecoration.BOLD, false)
                    );
        } else {
            newName = Component.text(player.getName())
                    .color(textColor)
                    .decoration(TextDecoration.BOLD, false);
        }

        // now set the name as display and list name
        setName(player, newName);
    }
}
